Bugzilla will be upgraded to version 5.0 on a still to be determined date in the near future. The original upgrade date has been delayed.

Bug 809898

Summary: RFE: add detection of Python bytecode for recent versions of Python
Product: Red Hat Enterprise Linux 6 Reporter: Dave Malcolm <dmalcolm>
Component: fileAssignee: Jan Kaluža <jkaluza>
Status: CLOSED ERRATA QA Contact: Eva Mrakova <emrakova>
Severity: medium Docs Contact:
Priority: low    
Version: 6.3CC: cww, dnovotny, emrakova, jkaluza, jorton, mmalik, salmy
Target Milestone: rcKeywords: FutureFeature
Target Release: 6.3   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: file-5.04-26.el6 Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of: 531082
: 1271636 (view as bug list) Environment:
Last Closed: 2016-05-10 15:46:17 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 531082    
Bug Blocks: 1172231, 1269913    

Description Dave Malcolm 2012-04-04 11:49:00 EDT
Can we ensure that "file" in RHEL6 identifies Python bytecode for all released versions of Python?
(i.e. 2.7, 3.0, 3.1, 3.2, and, later this year, 3.3)

I'm not sure if the Fedora work below made it into RHEL6:

+++ This bug was initially created as a clone of Bug #531082 +++

Created attachment 366152 [details]
Add bytecode values for Python 3.0 and 3.1

Description of problem:
Attached is a patch that adds support for Python 3.0 and Python 3.1 bytecode files to the .pyc/.pyo support.

With this file:
$ file /usr/lib/python3.1/re.pyo
/usr/lib/python3.1/re.pyo: python 3.1 byte-compiled

Caveat: only tested with 3.1; I calculated up the value for 3.0 from the source in python's py3k branch's Python/import.c:
[snip]
       Python 3.0a5: 3130 (lexical exception stacking, including POP_EXCEPT)
[snip]
       Python 3.1a0: 3150 (optimize conditional branches:
			   introduce POP_JUMP_IF_FALSE and POP_JUMP_IF_TRUE)
[snip]

Note that the value has 1 added to it in py3k's _PyImport_Init,
giving:
  python 3.0: magic=3131 = 0x0c3b (hex) =  0x3b 0x0c 0xc0 0xd0a (header)
and 
  python 3.1: magic=3151 = 0x0c4f (hex) =  0x4f 0x0c 0x0d 0x0a (header)

--- Additional comment from dmalcolm@redhat.com on 2009-10-26 16:17:38 EDT ---

>  python 3.0: magic=3131 = 0x0c3b (hex) =  0x3b 0x0c 0xc0 0xd0a (header)
should read:
>  python 3.0: magic=3131 = 0x0c3b (hex) =  0x3b 0x0c 0xc0 0x0a (header)

--- Additional comment from dmalcolm@redhat.com on 2009-10-26 16:50:27 EDT ---

I've sent the patch to the upstream mailing list (file@mx.gw.com), but it's current stuck in the moderator queue as I'm not yet subscribed (they seem to require human intervention for approving subscriptions)

--- Additional comment from dnovotny@redhat.com on 2009-10-27 08:51:03 EDT ---

hello Dave, thanks for the patch, added in file-5.03-11.fc13

I am subscribed to the list, so if your post doesn't show up there I can send the patch from my address.

--- Additional comment from dnovotny@redhat.com on 2009-10-27 10:04:57 EDT ---

...now I see your mail in the upstream mailing list

--- Additional comment from dmalcolm@redhat.com on 2009-10-27 10:15:00 EDT ---

(In reply to comment #4)
> ...now I see your mail in the upstream mailing list  
http://mx.gw.com/pipermail/file/2009/000483.html
Comment 2 Jan Kaluža 2012-04-10 05:32:46 EDT
Well, Python releases happen faster than RHEL6 updates, so as regular rule we can't ensure that. In the time of Bug 557608, Python 2.7 and 3.2 was not released yet.
Comment 3 RHEL Product and Program Management 2013-10-13 20:43:42 EDT
This request was evaluated by Red Hat Product Management for
inclusion in the current release of Red Hat Enterprise Linux.
Because the affected component is not scheduled to be updated
in the current release, Red Hat is unable to address this
request at this time.

Red Hat invites you to ask your support representative to
propose this request, if appropriate, in the next release of
Red Hat Enterprise Linux.
Comment 19 errata-xmlrpc 2016-05-10 15:46:17 EDT
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2016-0760.html